<script setup lang="ts">
import { ref, onMounted } from "vue";
import { useQuasar, type QTableProps } from "quasar";

import http from "@/plugins/http";
import config from "@/app.config";
import { useCounterMixin } from "@/stores/mixin";
import { useDataStore } from "@/stores/data";

import type {
  AssessmentsFormType,
  DataOption,
} from "@/modules/10_registry/interface/index/Main";

import DialogHistory from "@/modules/10_registry/Dialog/DialogHistory.vue";

const $q = useQuasar();
const dataPerson = useDataStore();
const { messageError, date2Thai, onSearchDataTable } = useCounterMixin();

const mode = ref<boolean>($q.screen.gt.xs); //โหมดแสดงผล
const link = ref<string>(""); //ลิงค์สำหรับดึงข้อมูล
const rows = ref<AssessmentsFormType[]>([]); //ตัวแปรเก็บข้อมูลที่ดึงมา
const rowsData = ref<AssessmentsFormType[]>([]); //ตัวแปรเก็บข้อมูลที่ดึงมาไว้สำหรับค้นหา
const filter = ref<string>(""); //ตัวแปรเก็บค่าค้นหา
const idByRow = ref<string>(""); //ตัวแปรเก็บ id ของแถวที่เลือก
const rowsHistory = ref<AssessmentsFormType[]>([]); //ตัวแปรเก็บข้อมูลประวัติการแก้ไข
const rowsHistoryData = ref<AssessmentsFormType[]>([]); //ตัวแปรเก็บข้อมูลประวัติการแก้ไขไว้สำหรับค้นหา
const isLoading = ref<boolean>(false); //ตัวแปรสำหรับแสดงสถานะการ
const isLoadingHistory = ref<boolean>(false); //ตัวแปรสำหรับแสดงสถานะการโหลดข้อมูลประวัติ
const periodOp = ref<DataOption[]>([
  { id: "OCT", name: "ตุลาคม" },
  { id: "APR", name: "เมษายน" },
]);
const modalHistory = ref<boolean>(false); //ตัวแปรสำหรับเปิดปิด modal ประวัติการแก้ไข
const columns = ref<QTableProps["columns"]>([
  {
    name: "date",
    align: "left",
    label: "วันที่ได้รับ",
    sortable: true,
    field: "date",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    format: (v) => date2Thai(v),
  },
  {
    name: "year",
    align: "left",
    label: "ปีงบประมาณ",
    sortable: true,
    field: "year",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    format: (v) => {
      return `${v ? Number(v) + 543 : "-"}`;
    },
  },
  {
    name: "period",
    align: "left",
    label: "รอบการประเมิน",
    sortable: true,
    field: "period",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    format: (v) => {
      return (
        periodOp.value.find((item: DataOption) => item.id === v)?.name || "-"
      );
    },
  },
  {
    name: "point1Total",
    align: "left",
    label: "ส่วนที่1 (คะแนน)",
    sortable: true,
    field: "point1Total",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "point1",
    align: "left",
    label: "ผลประเมินส่วนที่1 (คะแนน)",
    sortable: true,
    field: "point1",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "point2Total",
    align: "left",
    label: "ส่วนที่2 (คะแนน)",
    sortable: true,
    field: "point2Total",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "point2",
    align: "left",
    label: "ผลประเมินส่วนที่2 (คะแนน)",
    sortable: true,
    field: "point2",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "pointSumTotal",
    align: "left",
    label: "ผลรวม (คะแนน)",
    sortable: true,
    field: "pointSumTotal",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "pointSum",
    align: "left",
    label: "ผลประเมินรวม (คะแนน)",
    sortable: true,
    field: "pointSum",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "name",
    align: "left",
    label: "ผลประเมิน",
    sortable: true,
    field: (v) => `${textPoint(v.pointSum)} ${textRangePoint(v.pointSum)}`,
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "lastUpdateFullName",
    align: "left",
    label: "ผู้ดำเนินการ",
    sortable: true,
    field: "lastUpdateFullName",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "lastUpdatedAt",
    align: "left",
    label: "วันที่แก้ไข",
    sortable: true,
    field: "lastUpdatedAt",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    format: (v) => date2Thai(v, false, true),
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
]);
const columnsHistory = ref<QTableProps["columns"]>([
  {
    name: "date",
    align: "left",
    label: "วันที่ได้รับ",
    sortable: true,
    field: "date",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    format: (v) => date2Thai(v),
  },
  {
    name: "year",
    align: "left",
    label: "ปีงบประมาณ",
    sortable: true,
    field: "year",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    format: (v) => {
      return `${v ? Number(v) + 543 : "-"}`;
    },
  },
  {
    name: "period",
    align: "left",
    label: "รอบการประเมิน",
    sortable: true,
    field: "period",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    format: (v) => {
      return (
        periodOp.value.find((item: DataOption) => item.id === v)?.name || "-"
      );
    },
  },
  {
    name: "point1Total",
    align: "left",
    label: "ส่วนที่1 (คะแนน)",
    sortable: true,
    field: "point1Total",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
  },
  {
    name: "point1",
    align: "left",
    label: "ผลประเมินส่วนที่1 (คะแนน)",
    sortable: true,
    field: "point1",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "point2Total",
    align: "left",
    label: "ส่วนที่2 (คะแนน)",
    sortable: true,
    field: "point2Total",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "point2",
    align: "left",
    label: "ผลประเมินส่วนที่2 (คะแนน)",
    sortable: true,
    field: "point2",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "pointSumTotal",
    align: "left",
    label: "ผลรวม (คะแนน)",
    sortable: true,
    field: "pointSumTotal",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "pointSum",
    align: "left",
    label: "ผลประเมินรวม (คะแนน)",
    sortable: true,
    field: "pointSum",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "name",
    align: "left",
    label: "ผลประเมิน",
    sortable: true,
    field: (v) => `${textPoint(v.pointSum)} ${textRangePoint(v.pointSum)}`,
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "lastUpdateFullName",
    align: "left",
    label: "ผู้ดำเนินการ",
    sortable: true,
    field: "lastUpdateFullName",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "lastUpdatedAt",
    align: "left",
    label: "วันที่แก้ไข",
    sortable: true,
    field: "lastUpdatedAt",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    format: (v) => date2Thai(v, false, true),
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
]);
const visibleColumnsHistory = ref<string[]>([
  "point1Total",
  "year",
  "period",
  "point1",
  "point2Total",
  "point2",
  "pointSumTotal",
  "pointSum",
  "name",
  "date",
  "lastUpdateFullName",
  "lastUpdatedAt",
]);
const pagination = ref({
  sortBy: "lastUpdatedAt",
});
const visibleColumns = ref<string[]>([
  "point1Total",
  "year",
  "period",
  "point1",
  "point2Total",
  "point2",
  "pointSumTotal",
  "pointSum",
  "name",
  "date",
  "lastUpdateFullName",
  "lastUpdatedAt",
]);

/** ฟังก์ชันดึงข้อมูล */
async function getData() {
  isLoading.value = true;
  await http
    .get(config.API.dataUserCertificateByType(link.value, "assessments"))
    .then((res) => {
      const data = res.data.result;
      rows.value = data;
      rowsData.value = data;
    })
    .catch((e) => {
      messageError($q, e);
    })
    .finally(() => {
      isLoading.value = false;
    });
}

/**
 * ฟังก์ชันเปิด modal ประวัติการแก้ไข
 * @param id - id ของแถวที่เลือก
 */
function onHistory(id: string) {
  modalHistory.value = true;
  idByRow.value = id;
}

/** ฟังก์ชันดึงข้อมูลประวัติการแก้ไข */
async function getHistory() {
  isLoadingHistory.value = true;
  rowsHistory.value = [];
  rowsHistoryData.value = [];
  await http
    .get(
      config.API.dataUserCertificateHistoryByType(
        link.value,
        "assessments",
        idByRow.value
      )
    )
    .then((res) => {
      const data = res.data.result;
      rowsHistory.value = data;
      rowsHistoryData.value = data;
    })
    .catch((e) => {
      messageError($q, e);
    })
    .finally(() => {
      isLoadingHistory.value = false;
    });
}

/**
 * ฟังก์ชันตรวจสอบช่วงคะแนน
 * @param val - ค่าที่ต้องการตรวจสอบ
 */
function textRangePoint(val: number | undefined) {
  if (val == undefined) val = -1;
  if (val < 60.0) return "(คะแนนต่ำกว่าร้อยละ 60.00)";
  if (val >= 60.0 && val <= 69.99) return "(คะแนนร้อยละ 60.00 - 69.99)";
  if (val >= 70.0 && val <= 79.99) return "(คะแนนร้อยละ 70.00 - 79.99)";
  if (val >= 80.0 && val <= 89.99) return " (คะแนนร้อยละ 80.00 - 89.99)";
  if (val >= 90.0) return " (คะแนนร้อยละ 90.00 ขึ้นไป)";
  else return "";
}

/**
 * ฟังก์ชันตรวจสอบคะแนน
 * @param val - ค่าที่ต้องการตรวจสอบ
 */
function textPoint(val: number | undefined) {
  if (val == undefined) val = -1;
  if (val < 60.0) return "ต้องปรับปรุง";
  if (val >= 60.0 && val <= 69.99) return "พอใช้";
  if (val >= 70.0 && val <= 79.99) return "ดี";
  if (val >= 80.0 && val <= 89.99) return "ดีมาก";
  if (val >= 90.0) return "ดีเด่น";
  else return "-";
}

function onSearch() {
  rows.value = onSearchDataTable(
    filter.value,
    rowsData.value,
    columns.value ? columns.value : []
  );
}

onMounted(async () => {
  link.value = await dataPerson.getProFileType();
  getData();
});
</script>
<template>
  <!-- v-if="mode" -->
  <div class="col-12">
    <q-toolbar class="q-px-none q-mt-md">
      <span class="text-blue-6 text-weight-bold text-body1"
        >ผลการประเมินการปฏิบัติราชการ</span
      >
      <q-space />
      <q-input
        v-if="mode"
        class="inputgreen"
        outlined
        dense
        v-model="filter"
        label="ค้นหา"
        style="max-width: 200px"
        @keydown.enter.prevent="onSearch"
      >
        <template v-slot:append>
          <q-icon name="search" />
        </template>
      </q-input>
      <q-select
        v-if="mode"
        class="q-ml-sm"
        dense
        multiple
        outlined
        emit-value
        map-options
        options-dense
        option-value="name"
        style="min-width: 140px"
        v-model="visibleColumns"
        :options="columns"
        :display-value="$q.lang.table.columns"
      />
    </q-toolbar>

    <d-table
      flat
      dense
      bordered
      virtual-scroll
      :rows="rows.length !== 0 ? rows : []"
      :columns="columns"
      :grid="!mode"
      :rows-per-page-options="[10, 25, 50, 100]"
      :visible-columns="visibleColumns"
      :virtual-scroll-sticky-size-start="48"
      :pagination="pagination"
      :loading="isLoading"
      row-key="id"
    >
      <template v-slot:header="props">
        <q-tr :props="props">
          <q-th v-for="col in props.cols" :key="col.name" :props="props">
            <span class="text-weight-medium">{{ col.label }}</span>
          </q-th>
          <q-th auto-width />
        </q-tr>
      </template>

      <template v-if="mode" v-slot:body="props">
        <q-tr :props="props" class="cursor-pointer">
          <q-td v-for="(col, index) in props.cols" :key="col.name">
            <div v-if="col.name == 'no'">
              {{ props.rowIndex + 1 }}
            </div>
            <div v-else-if="col.name == 'status'">
              {{ props.row.status ? props.row.status : "-" }}
            </div>
            <div v-else>
              {{ col.value ? col.value : "-" }}
            </div>
          </q-td>
          <q-td auto-width>
            <q-btn
              color="info"
              flat
              dense
              round
              size="14px"
              icon="mdi-history"
              @click="onHistory(props.row.id)"
            >
              <q-tooltip>ประวัติแก้ไขผลการประเมินการปฏิบัติราชการ</q-tooltip>
            </q-btn>
          </q-td>
        </q-tr>
      </template>
      <template v-else v-slot:item="props">
        <div class="q-mb-xs col-xs-12 col-sm-6 col-md-4 col-lg-3">
          <q-card bordered flat>
            <q-list dense class="q-mt-lg relative-position">
              <q-btn
                icon="mdi-history"
                color="info"
                flat
                dense
                round
                size="14px"
                class="absolute_button"
                @click="onHistory(props.row.id)"
              >
                <q-tooltip>ประวัติแก้ไขผลการประเมินการปฏิบัติราชการ</q-tooltip>
              </q-btn>
              <q-item v-for="col in props.cols" :key="col.name">
                <q-item-section class="fix_top">
                  <q-item-label class="text-grey-6 text-weight-medium">{{
                    col.label
                  }}</q-item-label>
                </q-item-section>
                <q-item-section class="fix_top">
                  <q-item-label class="text-dark text-weight-medium">{{
                    col.value ? col.value : "-"
                  }}</q-item-label>
                </q-item-section>
              </q-item>
            </q-list>
          </q-card>
        </div>
      </template>
    </d-table>
  </div>

  <DialogHistory
    v-model:modal="modalHistory"
    :title="'ประวัติแก้ไขผลการประเมินการปฏิบัติราชการ'"
    :getData="getHistory"
    :rows="rowsHistory"
    :rows-data="rowsHistoryData"
    :visibleColumns="visibleColumnsHistory"
    :columns="columnsHistory"
    :is-loading="isLoadingHistory"
  />
</template>

<style scoped>
.absolute_button {
  position: absolute;
  right: 5px;
  top: -20px;
}

.fix_top {
  justify-content: start !important;
}
</style>
